#! /usr/bin/perl

# ================================================================== #
#  Fumy Redirect CGI   Ver 1.00   [r.cgi]                            #
# ================================================================== #
#  Copyright (C) Fumihiro-Nishimura.(Nishishi) 2006.                 #
#                                                                    #
#  w肳ꂽURLփ_CNgCGIłB                        #
#  _CNg͕o^ł܂B                                #
#  URLZ\ړIȂǂłpłł傤B             #
#                                                                    #
#  CGI͂ǂȂłRɂgp܂BlEp₢܂B #
#  ȂA쌠\͍폜EςȂŉB                      #
#                                                                    #
#  http://www.nishishi.com/                                          #
# ================================================================== #

use warnings;
use strict;

# ================ #
#  [Uݒ聥  #
# ================ #

# f[^t@C(CSV)
my $datafile = 'redirects.csv';

# ꗗ\邩ǂ(1:,0:Ȃ)
my $listshow = 1;

# CGĨt@CiT[oł̌ĂяoɎǵj
my $myname = 'r.cgi';

# ---------------------------------- #
# ȍ~ɐݒ荀ڂ͂܂ #
# ---------------------------------- #
my $param = &getparam();
print 'Location: ' . &checkurl(&checkdatas("$param")) . "\n\n";
exit;

# ---------------- #
# p[^̎擾 #
# ---------------- #
sub getparam
{
	my $query = $ENV{'QUERY_STRING'};

	# NGȂ
	if( $query eq "" ) {
		&defaultmsg();
	}

	return $query;
}

# -------------------------- #
# f[^̓ǂݍ݂ƈvmF #
# -------------------------- #
sub checkdatas
{
	my $checkstring = shift @_;

	# f[^t@CĂňvڂT
	my $redurl = "";

	if( open(IN,"$datafile") ) {
		foreach my $oneline ( <IN> ) {
			if( $oneline =~ m/^$checkstring,(.*)/ ) {
				# 烋[v𔲂
				$redurl = $1;
				last;
			}
		}
		close(IN);	# t@C
	}
	else {
		# ǂ߂ȂG[
		&errorexit("f[^t@C $datafile ǂ߂܂łB݂mFĉB");
	}

	return $redurl;
}

# ---------------------------- #
# f[^̓ǂݍ݂ƃXg\ #
# ---------------------------- #
sub showlist
{
	my @html;

	if( open(IN,"$datafile") ) {
		push(@html, qq|<table class="list" cellspacing="0">| );
		push(@html, qq|<tr><th>p[^</th><th>_CNgURL</th></tr>\n| );
		foreach my $oneline ( <IN> ) {
			my ($key,$value) = split(/,/, $oneline);
			push(@html, qq|<tr><th><a href="$myname?$key">$key</a></th><td>$value</td></tr>\n| );
		}
		close(IN);	# t@C
		push(@html, qq|</table>| );
	}
	else {
		# ǂ߂ȂG[
		&errorexit("f[^t@C $datafile ǂ߂܂łB݂mFĉB");
	}

	return @html;
}

# ------------- #
# URL̃`FbN #
# ------------- #
sub checkurl
{
	my $url = shift @_;

	if( $url eq "" ) {
		&errorexit('o^ĂȂ_CNg񂪎w肳܂B');
	}

	return $url;
}

# -------------------- #
# ftHgbZ[W #
# -------------------- #
sub defaultmsg
{
	my @listhtml = ();
	
	if( $listshow == 1 ) {
		# ꗗ\ꍇ
		@listhtml = &showlist();
	}

	print "Content-type: text/html\n\n";
	print qq|<html><head><title>Fumy Redirector CGI</title>\n<style type="text/css">\na { text-decoration:none; }\na:hover { color: red; background-color: #ffffcc; }\nh1 { font-family: sans-serif; border-bottom: 3px green solid; background-color: #ccffcc; }\ntable.list { border-collapse:collapse; border: 2px green solid; }\ntable.list th,table.list td { border: 1px solid green; padding: 0.1em 0.3em; }</style>\n</head><body><h1><a href="http://www.nishishi.com/">Fumy Redirector</a> CGI</h1><p>_CNg񂪎w肳Ă܂B</p>|;
	print @listhtml;
	print qq|</body></html>|;
	exit;
}

# ---------------- #
# G[bZ[W #
# ---------------- #
sub errorexit
{
	my $msg = shift @_;

	print "Content-type: text/html\n\n";
	print qq|<html lang="ja"><head><title>Fumy Redirector CGI ERROR</title></head><body>\n|;
	print qq|<div style="background-color:red; color:#fffff0; font-weight:bold; font-family:Arial,sans-serif; padding:1px;"> Fumy Redirector CGI ERROR </div><br>\n|;
	print qq|<div style="font-size: smaller;">G[eF</div>\n|;
	print qq|<div style="border:1px dotted blue; padding:1em;">$msg</div>\n|;
	print qq|<div style="text-align: right;"><form><input type="button" value="߂" onClick="history.back();"></form></div>|;
	print qq|<div style="font-size: 75%; font-family: Verdana,Arial,sans-serif; border-top: 1px solid #cccccc; padding-top: 0.3em;"><a href="http://www.nishishi.com/">Fumy Redirector CGI</a></div>|;
	print qq|</body></html>\n|;

	exit;
}
